#!/bin/csh
#-----------------------------------------------------------------------------
# 200708_LesHouches/src/BurgersEquation
#                                       Akira Kageyama
#                                       kage@jamstec.go.jp
#                                       Earth Simulator Center, JAMSTEC, Japan
#-----------------------------------------------------------------------------
# generate-plot-script.csh
#              2007.07.20: Created by Akira Kageyama
#-----------------------------------------------------------------------------

set namelist = sample.namelist

#--------

set pi = 3.14159265

set filebase = `grep '&data02 *Filename *=' $namelist | cut -d\' -f2`

echo '# gnuplot script generated by generate-plot-script.csh.'
echo '# '
echo ' '
echo 'set terminal aqua  # for MacBook Pro'
echo ' '
echo "set xrange [-$pi : $pi]"
echo 'set yrange [0 : 1.2]'
echo ' '

set pausetime_in_the_beginning  = 5  # wait for this seconds.
set pausetime_later = 0.1
set pausetime = $pausetime_in_the_beginning
foreach i (`ls $filebase.???`)
  echo plot \'$i\' w lp
  echo pause $pausetime
  set pausetime = $pausetime_later
end
