!-----------------------------------------------------------------------------
! grid.f90
!              2007.08.12: Created by Akira Kageyama.
!-----------------------------------------------------------------------------

module namelist
!*****************************************************************************
! MODULE NAMELIST                                              Namelist Loader
!*****************************************************************************
  use constants
  use ut
  implicit none
  private
  public :: & !< routines >!
!           namelist__double,   &
            namelist__integer,  &
!           namelist__logical,  &
            namelist__read,     &
            namelist__string

  logical, save :: Read_done = .false.

  integer                              :: Target_nloop
  character(len=TAG_STRING_LENGTH_MAX) :: Slicedata_filename

  namelist /data00/ Target_nloop
  namelist /data01/ Slicedata_filename


contains


! !________________________________________________________________public__
! !                                                                        !
!   function namelist__double(variable)                                    !
!     character(len=*), intent(in) :: variable                             !
!     real(DP) :: namelist__double                                         !
! !________________________________________________________________________!
! !
!     if ( .not.Read_done ) then
!        call ut__fatal('<namelist__double> Read namelist file first.')
!     end if

!     select case (variable)
!     case default
!        call ut__message('? arg = ', variable)
!        call ut__fatal('<namelist__double> not in the namelist?')
!     end select

!   end function namelist__double


!________________________________________________________________public__
!                                                                        !
  function namelist__integer(variable)                                   !
    character(len=*), intent(in) :: variable                             !
    integer :: namelist__integer                                         !
!________________________________________________________________________!
!
    if ( .not.Read_done ) then
       call ut__fatal('<namelist__integer> Read namelist file first.')
    end if

    select case (variable)
    case                 ('Target_nloop')
       namelist__integer = Target_nloop
    case default
       call ut__message('? arg = ', variable)
       call ut__fatal('<namelist__integer> not in the namelist?')
    end select

  end function namelist__integer


! !________________________________________________________________public__
! !                                                                        !
!   function namelist__logical(variable)                                   !
!     character(len=*), intent(in) :: variable                             !
!     logical :: namelist__logical                                         !
! !________________________________________________________________________!
! !
!     if ( .not.Read_done ) then
!        call ut__fatal('<namelist__logical> Read namelist file first.')
!     end if

!     select case (variable)
!     case default
!        call ut__message('? arg = ', variable)
!        call ut__fatal('<namelist__logical> not in the namelist?')
!     end select

!   end function namelist__logical


!________________________________________________________________public__
!                                                                        !
  subroutine namelist__read                                              !
!________________________________________________________________________!
!

    read(FILE_NAMELIST,nml=data00)
    read(FILE_NAMELIST,nml=data01)

    write(FILE_STANDARD_OUT,nml=data00)
    write(FILE_STANDARD_OUT,nml=data01)

    Read_done = .true.

  end subroutine namelist__read


!________________________________________________________________public__
!                                                                        !
  function namelist__string(variable)                                    !
    character(len=*), intent(in) :: variable                             !
    character(len=TAG_STRING_LENGTH_MAX) :: namelist__string             !
!________________________________________________________________________!
!
    if ( .not.Read_done ) then
       call ut__fatal('<namelist__string> Read namelist file first.')
    end if

    select case         (variable)
    case                ('Slicedata_filename')
       namelist__string = Slicedata_filename
    case default
       call ut__message('? arg = ', variable)
       call ut__fatal('<namelist__string> not in the namelist?')
    end select

  end function namelist__string

end module namelist
