!-----------------------------------------------------------------------------
! KINDANB: kinematic dynamo in a box
!-----------------------------------------------------------------------------
! constants.f90
!              2005.06.01: Created by Akira Kageyama.
!-----------------------------------------------------------------------------

module constants      
!*****************************************************************************
! MODULE CONSTANTS                                         Numerical Constants
!*****************************************************************************
  implicit none

  ! << f90 constants >>
  integer, parameter ::  SP = kind(1.0)
  integer, parameter ::  DP = selected_real_kind(2*precision(1.0_SP))
  integer, parameter :: DPC = kind((1.0_DP,1.0_DP))

  ! << Mathematical constants >>
  real(DP),     parameter ::    PI = 3.141592653589793238462643383279502884_DP
  real(DP),     parameter :: TWOPI = PI*2
  complex(DPC), parameter :: Z0 = (0.0_DP,0.0_DP)
  complex(DPC), parameter :: ZI = (0.0_DP,1.0_DP)

  ! << Job karte >>
  integer, parameter      :: KARTE_FINE      =  0
  integer, parameter      :: KARTE_TIME_OUT  =  1
  integer, parameter      :: KARTE_LOOP_MAX  =  2
  integer, parameter      :: KARTE_OVERFLOW  =  3
  integer, parameter      :: KARTE_UNDERFLOW =  4

  ! << I/O files >>
  integer, parameter      :: FILE_NAMELIST     = 05
  integer, parameter      :: FILE_RESTART      = 80
  integer, parameter      :: FILE_STANDARD_OUT = 06
  integer, parameter      :: FILE_AVS_DATA     = 50
  integer, parameter      :: FILE_SLICEDATA    = 51

  ! << Grid Size >>
  integer, parameter      :: NX = 10
  integer, parameter      :: NY = 10
  integer, parameter      :: NZ = 10

  ! << Box Size >>
  real(DP), parameter     :: XMIN = -PI
  real(DP), parameter     :: XMAX =  PI
  real(DP), parameter     :: YMIN = -PI
  real(DP), parameter     :: YMAX =  PI
  real(DP), parameter     :: ZMIN = -PI
  real(DP), parameter     :: ZMAX =  PI

  ! << Used for strings >>
  integer, parameter      :: TAG_STRING_LENGTH_MAX = 100

end module constants
